""" Buttons. """

from pgzero.actor import Actor
from pgzero.ptext import getsurf
from .surf import SurfActor


class ImageButton(Actor):
    def __init__(self, *args, action=None, **kwargs):
        super().__init__(*args, **kwargs)
        self.action = action


class TextButton(SurfActor):
    def __init__(self, text, action=None, **kwargs):
        self.text(text, **kwargs)
        super().__init__(self._surf)
        self.action = action

    def select(self):
        self.text(self._text, owidth=2, ocolor="white", color="black")

    def deselect(self):
        self.text(self._text)

    def text(self, text, **kw):
        self._text = text
        self._text_kwargs = kw
        self.surf = getsurf(text, **kw)
