# A doors / keypads set

import os
from pgzero.loaders import images
from ..actors.orientatedsurf import OrientatedSurfActor
from ..constants import TILE_SIZE


class Door(OrientatedSurfActor):

    def __init__(self, x, y, angle):
        self._closed = True
        self._open_surf = images.load(os.path.join('fixtures', 'door_open'))
        self._closed_surf = images.load(os.path.join('fixtures', 'door'))
        self.game_pos = (x, y)
        super().__init__(self._closed_surf, angle=angle, anchor=(0, 0))

    def open(self):
        self._closed = False
        self.surf = self._open_surf

    def close(self):
        self._closed = True
        self.surf = self._closed_surf

    def is_closed(self):
        return self._closed
