""" A vehicle to represent roaches on foot. """

from .base import Vehicle, circle_of_seats
from ..roaches import (
    default_roaches, roaches_quartet, roaches_nonet, WorldRoach)
from ..weapons import default_weapons


class Walking(Vehicle):

    vehicle_type = "walking"
    weapons_taped_on = False

    def init_seats(self):
        return circle_of_seats(6, vehicle=self)

    def get_avatar(self, world):
        weapon = default_weapons.assemble(
            world.weapons.current, tape=self.weapons_taped_on)
        num_roaches = len(world.roaches)
        roach = WorldRoach()
        if num_roaches == 1:
            # Return a single large roach
            avatar = default_roaches.assemble(roach, weapon=weapon)
            avatar.anchor = (0, 0)
        elif num_roaches < 6:
            avatar = roaches_quartet.assemble(roach, weapon=weapon)
            avatar.anchor = (0, 0)
        else:
            avatar = roaches_nonet.assemble(roach, weapon=weapon)
            avatar.anchor = (0, 0)
        return avatar
